image: docker:latest

variables:
  SONAR_LOGIN_TOKEN: 0445736f9ef22f67d873ae82bb8ab4a5a02bbee0
services:
- docker:dind
 
static_test:
    when:  always
    stage: test
    image: nikolaik/python-nodejs:latest
    before_script:
        - apt-get -qq update
        - apt-get install -y jq
        - wget https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-3.3.0.1492-linux.zip
        - $(unzip -q sonar-scanner-cli-3.3.0.1492-linux.zip || exit 0)
        - mv sonar-scanner-3.3.0.1492-linux/ /sonar
        - rm sonar-scanner-cli-3.3.0.1492-linux.zip
        - export PATH=$PATH:/sonar/bin/
        - echo $PATH_ 
    script:
        - ls
        - sonar-scanner -Dproject.settings=sonar-project.properties
        - sleep 60s #Wait time for the report
        - export url=$(cat .scannerwork/report-task.txt | grep ceTaskUrl | cut -c11- ) #URL where report gets stored
        - curl -k -u "$SONAR_LOGIN_TOKEN":"" $url -o analysis.txt
        - export status=$(cat analysis.txt | jq -r '.task.status') #Status as SUCCESS, CANCELED or FAILED
        - export analysisId=$(cat analysis.txt | jq -r '.task.analysisId') #Get the analysis Id
        - cat analysis.txt
        - |
            if [ "$status" == "IN_PROGRESS" ];then 
            echo -e "STILL PROCESSING ....";
            sleep 60s
            curl -k -u "$SONAR_LOGIN_TOKEN":"" $url -o analysis.txt
            export status=$(cat analysis.txt | jq -r '.task.status') #Status as SUCCESS, CANCELED or FAILED
            export analysisId=$(cat analysis.txt | jq -r '.task.analysisId') #Get the analysis Id
            fi
            
            if [ "$status" == "SUCCESS" ];then 
                echo -e "SONAR ANALYSIS SUCCESSFUL...ANALYSING RESULTS";
                curl -k -u "$SONAR_LOGIN_TOKEN":"" http://35.173.203.217:9000/api/qualitygates/project_status?analysisId=$analysisId -o result.txt; #Analysis result like critical, major and minor issues
                export result=$(cat result.txt | jq -r '.projectStatus.status');
    
                if [ "$result" == "ERROR" ];then
                echo -e "91mSONAR RESULTS FAILED";
                echo "$(cat result.txt | jq -r '.projectStatus.conditions')"; #prints the critical, major and minor violations
                 exit 1 #breaks the build for violations
                else
                echo -e "SONAR RESULTS SUCCESSFUL";
                echo "$(cat result.txt | jq -r '.projectStatus.conditions')";
                exit 0 
            fi
            else 
             echo -e "\e[91mSONAR ANALYSIS FAILED\e[0m";
             exit 1 #breaks the build for failure in Step2
            fi
